
%define tarball_name boost_1_33_1

Name: compat-boost-1331
Summary: The Boost C++ Libraries
Version: 1.33.1
Release: 5%{?dist}
License: Boost Software License
URL: http://www.boost.org/
Group: System Environment/Libraries
Source: %{tarball_name}.tar.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Prereq: /sbin/ldconfig
BuildRequires: libstdc++-devel python 
BuildRequires: bzip2-libs
BuildRequires: bzip2-devel
BuildRequires: zlib
BuildRequires: zlib-devel
BuildRequires: python-devel
Patch0: boost-base.patch
Patch1: boost-gcc-tools.patch
Patch2: boost-thread.patch
Patch3: boost-config-compiler-gcc.patch
Patch4: boost-runtests.patch
Patch5: boost-serialization-warnings.patch
Patch6: boost-spirit-warnings.patch
Patch7: boost-bind-gcc41.patch
Patch8: boost-cxxflags-debug.patch

#Patch101: boost_mrg-1.patch
#Patch102: boost_mrg-2.patch

%description
Boost provides free peer-reviewed portable C++ source libraries.  The
emphasis is on libraries which work well with the C++ Standard
Library, in the hopes of establishing "existing practice" for
extensions and providing reference implementations so that the Boost
libraries are suitable for eventual standardization. (Some of the
libraries have already been proposed for inclusion in the C++
Standards Committee's upcoming C++ Standard Library Technical Report.)

%package devel
Summary: The Boost C++ headers and development libraries
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
Headers, static libraries, and shared object symlinks for the Boost
C++ libraries

%package doc
Summary: The Boost C++ html docs
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}

%description doc
HTML documentation files for Boost C++ libraries

%prep
rm -rf $RPM_BUILD_ROOT

%setup -n %{tarball_name} -q
%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0

#%patch101 -p1
#%patch102 -p1

%build
#build bjam
(cd tools/build/jam_src && ./build.sh)

#build boost with bjam
BJAM=`find tools/build/jam_src/ -name bjam -a -type f`
#BUILD_FLAGS="-sTOOLS=gcc -sBUILD=release <dllversion>1"
#BUILD_FLAGS="-sTOOLS=gcc -sBUILD=release"
BUILD_FLAGS="-d2 -sTOOLS=gcc -sBUILD=release"
PYTHON_VERSION=$(python -c 'import sys; print sys.version[:3]')
PYTHON_FLAGS="-sPYTHON_ROOT=/usr -sPYTHON_VERSION=$PYTHON_VERSION"
$BJAM $PYTHON_FLAGS $BUILD_FLAGS stage 

%check
BOOST_ROOT=`pwd`;
cd tools/regression;
(cd ./build && $BOOST_ROOT/$BJAM)
echo "<p>" `uname -a` "</p>" > regression_comment.html;
echo "" >>  regression_comment.html;
echo "<p>" `g++ --version` "</p>" >> regression_comment.html;
chmod +x ./run_tests.sh;
#uncomment next line to run tests: warning, takes a long time
#./run_tests.sh;
results1=$BOOST_ROOT/status/results.html
results2=$BOOST_ROOT/status/results-links.html
if [ -f $results2 ] && [ -f $results2 ]; then
  testdate=`date +%Y%m%d`;
  testarch=`uname -m`;
  email=bkoz@redhat.com
  mail -s "$testdate boost regression $testarch 1" $email < $results1;
  mail -s "$testdate boost regression $testarch 2" $email < $results2;
fi
cd ../..;


%install
mkdir -p $RPM_BUILD_ROOT%{_libdir}

# install lib
mkdir -p $RPM_BUILD_ROOT%{_libdir}/boost-1_33_1/
for i in `find stage -type f -name \*.a`; do
  NAME=`basename $i`;
  install -m 755 $i $RPM_BUILD_ROOT%{_libdir}/boost-1_33_1/$NAME;
done;
for i in `find stage -type f -name \*.so.*`; do
  NAME=`basename $i`;
  install -m 755 $i $RPM_BUILD_ROOT%{_libdir}/$NAME;
done;
for i in `find stage -type l -name \*.so`; do
  NAME=`basename $i`;
  SONAME=$NAME.2;
  ln -s $NAME.%{version} $SONAME;
  mv $SONAME $RPM_BUILD_ROOT%{_libdir}/$SONAME
  ln -s ../$NAME.%{version} $RPM_BUILD_ROOT%{_libdir}/boost-1_33_1/$NAME
done;

# install include files
find boost -type d | while read a; do
  mkdir -p $RPM_BUILD_ROOT%{_includedir}/boost-1_33_1/$a
  find $a -mindepth 1 -maxdepth 1 -type f \
    | xargs -r -i -- install -m 644 -p {} $RPM_BUILD_ROOT%{_includedir}/boost-1_33_1/$a
done

%clean
rm -rf $RPM_BUILD_ROOT 

%post 
/sbin/ldconfig

%postun 
/sbin/ldconfig

%files 
%defattr(-, root, root)
%{_libdir}/*.so.%{version}
%{_libdir}/*.so.2

%files devel
%defattr(-, root, root)
%{_includedir}/boost-1_33_1/boost
%{_libdir}/boost-1_33_1/*.a
%{_libdir}/boost-1_33_1/*.so

%changelog
* Tue Jun 17 2008 Petr Machata <pmachata@redhat.com> - 1.33.1-5
- Fix bug in install script.
- Resolves: #438001

* Wed Apr 22 2008 Petr Machata <pmachata@redhat.com> - 1.33.1-4
- Re-introduce devel portion of the library.
- Resolves: #438001

* Wed Apr  9 2008 Petr Machata <pmachata@redhat.com> - 1.33.1-2
- Drop devel and doc portions of the library.

* Tue Mar 11 2008 Petr Machata <pmachata@redhat.com> - 1.33.1-1
- Initial package, forked from RHEL5's boost-1.33.1-10
